#include<bits/stdc++.h>
using namespace std;
int vis,c[500005],ans[500005],t,n,u,v,m,k;
vector<int> r[500005];
queue<int> q;
int main(){
	freopen("query.in","r",stdin);
	freopen("query.out","w",stdout);
	scanf("%d",&n);
	for(int i=1;i<n;i++){
		scanf("%d%d",&u,&v);
		r[u].push_back(v);
		r[v].push_back(u);
	}
	q.push(1);
	ans[1]=0;
	c[1]=1;
	while(!q.empty()){
		vis=q.front();
		q.pop();
		for(int i=0;i<r[vis].size();i++){
			if(ans[r[vis][i]]==0){
				ans[r[vis][i]]=vis;
				c[r[vis][i]]=c[vis]+1;
				q.push(r[vis][i]);
			}
		}
	}
	scanf("%d",&m);
	for(int i=1;i<=m;i++){
		scanf("%d%d%d",&u,&v,&k);
		while(v!=k){
			if(c[v]>c[k]) v=ans[v];
			else if(c[v]<c[k]) k=ans[k];
			else v=ans[v],k=ans[k];
		}
		printf("%d\n",c[v]);
	}
	return 0;
}

